Package org.eclipse.swt.widgets

# Class Table

java.lang.Object
org.eclipse.swt.widgets.Widget
org.eclipse.swt.widgets.Control
org.eclipse.swt.widgets.Scrollable
org.eclipse.swt.widgets.Composite
org.eclipse.swt.widgets.Table

All Implemented Interfaces:
  `Drawable`

public class Table extends Composite
Instances of this class implement a selectable user interface object that displays a list of images and strings and issues notification when selected.

The item children that may be added to instances of this class must be of type `TableItem`.

Style `VIRTUAL` is used to create a `Table` whose `TableItem`s are to be populated by the client on an on-demand basis instead of up-front. This can provide significant performance improvements for tables that are very large or for which `TableItem` population is expensive (for example, retrieving values from an external source).

Here is an example of using a `Table` with style `VIRTUAL`:

      final Table table = new Table (parent, SWT.VIRTUAL | SWT.BORDER);
      table.setItemCount (1000000);
      table.addListener (SWT.SetData, new Listener () {
          public void handleEvent (Event event) {
              TableItem item = (TableItem) event.item;
              int index = table.indexOf (item);
              item.setText ("Item " + index);
              System.out.println (item.getText ());
          }
      });

Note that although this class is a subclass of `Composite`, it does not normally make sense to add `Control` children to it, or set a layout on it, unless implementing something like a cell editor.

Styles:
  SINGLE, MULTI, CHECK, FULL_SELECTION, HIDE_SELECTION, VIRTUAL, NO_SCROLL, NO_SEARCH
Events:
  Selection, DefaultSelection, SetData, MeasureItem, EraseItem, PaintItem

Note: Only one of the styles SINGLE, and MULTI may be specified.

IMPORTANT: This class is not intended to be subclassed.

See Also:
  - Table, TableItem, TableColumn snippets
  - SWT Example: ControlExample
  - Sample code and further information
Restriction:
  This class is not intended to be subclassed by clients.

## Field Summary

### Fields inherited from class org.eclipse.swt.widgets.Control

`handle`

### Fields inherited from class org.eclipse.swt.widgets.Widget

`nativeZoom`

## Constructor Summary

Constructors
Constructor
Description
`Table(Composite parent, int style)`
Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

## Method Summary

Modifier and Type
Method
Description
`void`
`addSelectionListener(SelectionListener listener)`
Adds the listener to the collection of listeners who will be notified when the user changes the receiver's selection, by sending it one of the messages defined in the `SelectionListener` interface.
`protected void`
`checkSubclass()`
Checks that this class can be subclassed.
`void`
`clear(int index)`
Clears the item at the given zero-relative index in the receiver.
`void`
`clear(int[] indices)`
Clears the items at the given zero-relative indices in the receiver.
`void`
`clear(int start, int end)`
Removes the items from the receiver which are between the given zero-relative start and end indices (inclusive).
`void`
`clearAll()`
Clears all the items in the receiver.
`void`
`deselect(int index)`
Deselects the item at the given zero-relative index in the receiver.
`void`
`deselect(int[] indices)`
Deselects the items at the given zero-relative indices in the receiver.
`void`
`deselect(int start, int end)`
Deselects the items at the given zero-relative indices in the receiver.
`void`
`deselectAll()`
Deselects all selected items in the receiver.
`TableColumn`
`getColumn(int index)`
Returns the column at the given, zero-relative index in the receiver.
`int`
`getColumnCount()`
Returns the number of columns contained in the receiver.
`int[]`
`getColumnOrder()`
Returns an array of zero-relative integers that map the creation order of the receiver's items to the order in which they are currently being displayed.
`TableColumn[]`
`getColumns()`
Returns an array of `TableColumn`s which are the columns in the receiver.
`int`
`getGridLineWidth()`
Returns the width in points of a grid line.
`Color`
`getHeaderBackground()`
Returns the header background color.
`Color`
`getHeaderForeground()`
Returns the header foreground color.
`int`
`getHeaderHeight()`
Returns the height of the receiver's header
`boolean`
`getHeaderVisible()`
Returns `true` if the receiver's header is visible, and `false` otherwise.
`TableItem`
`getItem(int index)`
Returns the item at the given, zero-relative index in the receiver.
`TableItem`
`getItem(Point point)`
Returns the item at the given point in the receiver or null if no such item exists.
`int`
`getItemCount()`
Returns the number of items contained in the receiver.
`int`
`getItemHeight()`
Returns the height of the area which would be used to display one of the items in the receiver.
`TableItem[]`
`getItems()`
Returns a (possibly empty) array of `TableItem`s which are the items in the receiver.
`boolean`
`getLinesVisible()`
Returns `true` if the receiver's lines are visible, and `false` otherwise.
`TableItem[]`
`getSelection()`
Returns an array of `TableItem`s that are currently selected in the receiver.
`int`
`getSelectionCount()`
Returns the number of selected items contained in the receiver.
`int`
`getSelectionIndex()`
Returns the zero-relative index of the item which is currently selected in the receiver, or -1 if no item is selected.
`int[]`
`getSelectionIndices()`
Returns the zero-relative indices of the items which are currently selected in the receiver.
`TableColumn`
`getSortColumn()`
Returns the column which shows the sort indicator for the receiver.
`int`
`getSortDirection()`
Returns the direction of the sort indicator for the receiver.
`int`
`getTopIndex()`
Returns the zero-relative index of the item which is currently at the top of the receiver.
`int`
`indexOf(TableColumn column)`
Searches the receiver's list starting at the first column (index 0) until a column is found that is equal to the argument, and returns the index of that column.
`int`
`indexOf(TableItem item)`
Searches the receiver's list starting at the first item (index 0) until an item is found that is equal to the argument, and returns the index of that item.
`boolean`
`isSelected(int index)`
Returns `true` if the item is selected, and `false` otherwise.
`void`
`remove(int index)`
Removes the item from the receiver at the given zero-relative index.
`void`
`remove(int[] indices)`
Removes the items from the receiver's list at the given zero-relative indices.
`void`
`remove(int start, int end)`
Removes the items from the receiver which are between the given zero-relative start and end indices (inclusive).
`void`
`removeAll()`
Removes all of the items from the receiver.
`void`
`removeSelectionListener(SelectionListener listener)`
Removes the listener from the collection of listeners who will be notified when the user changes the receiver's selection.
`void`
`select(int index)`
Selects the item at the given zero-relative index in the receiver.
`void`
`select(int[] indices)`
Selects the items at the given zero-relative indices in the receiver.
`void`
`select(int start, int end)`
Selects the items in the range specified by the given zero-relative indices in the receiver.
`void`
`selectAll()`
Selects all of the items in the receiver.
`void`
`setColumnOrder(int[] order)`
Sets the order that the items in the receiver should be displayed in to the given argument which is described in terms of the zero-relative ordering of when the items were added.
`void`
`setFont(Font font)`
Sets the font that the receiver will use to paint textual information to the font specified by the argument, or to the default font for that kind of control if the argument is null.
`void`
`setHeaderBackground(Color color)`
Sets the header background color to the color specified by the argument, or to the default system color if the argument is null.
`void`
`setHeaderForeground(Color color)`
Sets the header foreground color to the color specified by the argument, or to the default system color if the argument is null.
`void`
`setHeaderVisible(boolean show)`
Marks the receiver's header as visible if the argument is `true`, and marks it invisible otherwise.
`void`
`setItemCount(int count)`
Sets the number of items contained in the receiver.
`void`
`setLinesVisible(boolean show)`
Marks the receiver's lines as visible if the argument is `true`, and marks it invisible otherwise.
`void`
`setRedraw(boolean redraw)`
If the argument is `false`, causes subsequent drawing operations in the receiver to be ignored.
`void`
`setSelection(int index)`
Selects the item at the given zero-relative index in the receiver.
`void`
`setSelection(int[] indices)`
Selects the items at the given zero-relative indices in the receiver.
`void`
`setSelection(int start, int end)`
Selects the items in the range specified by the given zero-relative indices in the receiver.
`void`
`setSelection(TableItem item)`
Sets the receiver's selection to the given item.
`void`
`setSelection(TableItem[] items)`
Sets the receiver's selection to be the given array of items.
`void`
`setSortColumn(TableColumn column)`
Sets the column used by the sort indicator for the receiver.
`void`
`setSortDirection(int direction)`
Sets the direction of the sort indicator for the receiver.
`void`
`setTopIndex(int index)`
Sets the zero-relative index of the item which is currently at the top of the receiver.
`void`
`showColumn(TableColumn column)`
Shows the column.
`void`
`showItem(TableItem item)`
Shows the item.
`void`
`showSelection()`
Shows the selection.

### Methods inherited from class org.eclipse.swt.widgets.Composite

`changed, drawBackground, getBackgroundMode, getChildren, getLayout, getLayoutDeferred, getTabList, isLayoutDeferred, layout, layout, layout, layout, layout, setBackgroundMode, setFocus, setLayout, setLayoutDeferred, setTabList, toString`

### Methods inherited from class org.eclipse.swt.widgets.Scrollable

`computeTrim, getClientArea, getHorizontalBar, getScrollbarsMode, getVerticalBar, setScrollbarsMode`

### Methods inherited from class org.eclipse.swt.widgets.Control

`addControlListener, addDragDetectListener, addFocusListener, addGestureListener, addHelpListener, addKeyListener, addMenuDetectListener, addMouseListener, addMouseMoveListener, addMouseTrackListener, addMouseWheelListener, addPaintListener, addTouchListener, addTraverseListener, computeSize, computeSize, dragDetect, dragDetect, forceFocus, getAccessible, getBackground, getBackgroundImage, getBorderWidth, getBounds, getCursor, getData, getDragDetect, getEnabled, getFont, getForeground, getLayoutData, getLocation, getMenu, getMonitor, getOrientation, getParent, getRegion, getShell, getSize, getTextDirection, getToolTipText, getTouchEnabled, getVisible, internal_dispose_GC, internal_new_GC, isEnabled, isFocusControl, isReparentable, isVisible, moveAbove, moveBelow, pack, pack, print, redraw, redraw, removeControlListener, removeDragDetectListener, removeFocusListener, removeGestureListener, removeHelpListener, removeKeyListener, removeMenuDetectListener, removeMouseListener, removeMouseMoveListener, removeMouseTrackListener, removeMouseWheelListener, removePaintListener, removeTouchListener, removeTraverseListener, requestLayout, setAutoscalingMode, setBackground, setBackgroundImage, setBounds, setBounds, setCapture, setCursor, setData, setDragDetect, setEnabled, setForeground, setLayoutData, setLocation, setLocation, setMenu, setOrientation, setParent, setRegion, setSize, setSize, setTextDirection, setToolTipText, setTouchEnabled, setVisible, toControl, toControl, toDisplay, toDisplay, traverse, traverse, traverse, update`

### Methods inherited from class org.eclipse.swt.widgets.Widget

`addDisposeListener, addListener, addTypedListener, checkWidget, dispose, getData, getDisplay, getListeners, getStyle, getTypedListeners, isAutoDirection, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, removeListener, removeTypedListener, reskin, setData`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.eclipse.swt.graphics.Drawable

`isAutoScalable`

## Constructor Details

### Table

public Table(Composite parent, int style)
Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a composite control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  - `SWT.SINGLE`
  - `SWT.MULTI`
  - `SWT.CHECK`
  - `SWT.FULL_SELECTION`
  - `SWT.HIDE_SELECTION`
  - `SWT.VIRTUAL`
  - `SWT.NO_SCROLL`
  - `Widget.checkSubclass()`
  - `Widget.getStyle()`

## Method Details

### addSelectionListener

public void addSelectionListener(SelectionListener listener)
Adds the listener to the collection of listeners who will be notified when the user changes the receiver's selection, by sending it one of the messages defined in the `SelectionListener` interface.

When `widgetSelected` is called, the item field of the event object is valid. If the receiver has the `SWT.CHECK` style and the check selection changes, the event object detail field contains the value `SWT.CHECK`. `widgetDefaultSelected` is typically called when an item is double-clicked. The item field of the event object is valid for default selection, but the detail field is not used.

Parameters:
  `listener` - the listener which should be notified when the user changes the receiver's selection
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `SelectionListener`
  - `removeSelectionListener(org.eclipse.swt.events.SelectionListener)`
  - `SelectionEvent`

### checkSubclass

protected void checkSubclass()
Description copied from class: `Widget`
Checks that this class can be subclassed.

The SWT class library is intended to be subclassed only at specific, controlled points (most notably, `Composite` and `Canvas` when implementing new widgets). This method enforces this rule unless it is overridden.

IMPORTANT: By providing an implementation of this method that allows a subclass of a class which does not normally allow subclassing to be created, the implementer agrees to be fully responsible for the fact that any such subclass will likely fail between SWT releases and will be strongly platform specific. No support is provided for user-written classes which are implemented in this fashion.

The ability to subclass outside of the allowed SWT classes is intended purely to enable those not on the SWT development team to implement patches in order to get around specific limitations in advance of when those limitations can be addressed by the team. Subclassing should not be attempted without an intimate and detailed understanding of the hierarchy.

Overrides:
  `checkSubclass` in class `Composite`

### clear

public void clear(int index)
Clears the item at the given zero-relative index in the receiver. The text, icon and other attributes of the item are set to the default value. If the table was created with the `SWT.VIRTUAL` style, these attributes are requested again as needed.

Parameters:
  `index` - the index of the item to clear
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.0
See Also:
  - `SWT.VIRTUAL`
  - `SWT.SetData`

### clear

public void clear(int start, int end)
Removes the items from the receiver which are between the given zero-relative start and end indices (inclusive). The text, icon and other attributes of the items are set to their default values. If the table was created with the `SWT.VIRTUAL` style, these attributes are requested again as needed.

Parameters:
  `start` - the start index of the item to clear
  `end` - the end index of the item to clear
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if either the start or end are not between 0 and the number of elements in the list minus 1 (inclusive)
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.0
See Also:
  - `SWT.VIRTUAL`
  - `SWT.SetData`

### clear

public void clear(int[] indices)
Clears the items at the given zero-relative indices in the receiver. The text, icon and other attributes of the items are set to their default values. If the table was created with the `SWT.VIRTUAL` style, these attributes are requested again as needed.

Parameters:
  `indices` - the array of indices of the items
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
  - ERROR_NULL_ARGUMENT - if the indices array is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.0
See Also:
  - `SWT.VIRTUAL`
  - `SWT.SetData`

### clearAll

public void clearAll()
Clears all the items in the receiver. The text, icon and other attributes of the items are set to their default values. If the table was created with the `SWT.VIRTUAL` style, these attributes are requested again as needed.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.0
See Also:
  - `SWT.VIRTUAL`
  - `SWT.SetData`

### deselect

public void deselect(int[] indices)
Deselects the items at the given zero-relative indices in the receiver. If the item at the given zero-relative index in the receiver is selected, it is deselected. If the item at the index was not selected, it remains deselected. Indices that are out of range and duplicate indices are ignored.

Parameters:
  `indices` - the array of indices for the items to deselect
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the set of indices is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### deselect

public void deselect(int index)
Deselects the item at the given zero-relative index in the receiver. If the item at the index was already deselected, it remains deselected. Indices that are out of range are ignored.

Parameters:
  `index` - the index of the item to deselect
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### deselect

public void deselect(int start, int end)
Deselects the items at the given zero-relative indices in the receiver. If the item at the given zero-relative index in the receiver is selected, it is deselected. If the item at the index was not selected, it remains deselected. The range of the indices is inclusive. Indices that are out of range are ignored.

Parameters:
  `start` - the start index of the items to deselect
  `end` - the end index of the items to deselect
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### deselectAll

public void deselectAll()
Deselects all selected items in the receiver.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getColumn

public TableColumn getColumn(int index)
Returns the column at the given, zero-relative index in the receiver. Throws an exception if the index is out of range. Columns are returned in the order that they were created. If no `TableColumn`s were created by the programmer, this method will throw `ERROR_INVALID_RANGE` despite the fact that a single column of data may be visible in the table. This occurs when the programmer uses the table like a list, adding items but never creating a column.

Parameters:
  `index` - the index of the column to return
Returns:
  the column at the given index
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `getColumnOrder()`
  - `setColumnOrder(int[])`
  - `TableColumn.getMoveable()`
  - `TableColumn.setMoveable(boolean)`
  - `SWT.Move`

### getColumnCount

public int getColumnCount()
Returns the number of columns contained in the receiver. If no `TableColumn`s were created by the programmer, this value is zero, despite the fact that visually, one column of items may be visible. This occurs when the programmer uses the table like a list, adding items but never creating a column.

Returns:
  the number of columns
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getColumnOrder

public int[] getColumnOrder()
Returns an array of zero-relative integers that map the creation order of the receiver's items to the order in which they are currently being displayed.

Specifically, the indices of the returned array represent the current visual order of the items, and the contents of the array represent the creation order of the items.

Note: This is not the actual structure used by the receiver to maintain its list of items, so modifying the array will not affect the receiver.

Returns:
  the current visual order of the receiver's items
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.1
See Also:
  - `setColumnOrder(int[])`
  - `TableColumn.getMoveable()`
  - `TableColumn.setMoveable(boolean)`
  - `SWT.Move`

### getColumns

public TableColumn[] getColumns()
Returns an array of `TableColumn`s which are the columns in the receiver. Columns are returned in the order that they were created. If no `TableColumn`s were created by the programmer, the array is empty, despite the fact that visually, one column of items may be visible. This occurs when the programmer uses the table like a list, adding items but never creating a column.

Note: This is not the actual structure used by the receiver to maintain its list of items, so modifying the array will not affect the receiver.

Returns:
  the items in the receiver
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `getColumnOrder()`
  - `setColumnOrder(int[])`
  - `TableColumn.getMoveable()`
  - `TableColumn.setMoveable(boolean)`
  - `SWT.Move`

### getGridLineWidth

public int getGridLineWidth()
Returns the width in points of a grid line.

Returns:
  the width of a grid line in points
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getHeaderBackground

public Color getHeaderBackground()
Returns the header background color.

Returns:
  the receiver's header background color.
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.106

### getHeaderForeground

public Color getHeaderForeground()
Returns the header foreground color.

Returns:
  the receiver's header foreground color.
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.106

### getHeaderHeight

public int getHeaderHeight()
Returns the height of the receiver's header

Returns:
  the height of the header or zero if the header is not visible
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  2.0

### getHeaderVisible

public boolean getHeaderVisible()
Returns `true` if the receiver's header is visible, and `false` otherwise.

If one of the receiver's ancestors is not visible or some other condition makes the receiver not visible, this method may still indicate that it is considered visible even though it may not actually be showing.

Returns:
  the receiver's header's visibility state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getItem

public TableItem getItem(int index)
Returns the item at the given, zero-relative index in the receiver. Throws an exception if the index is out of range.

Parameters:
  `index` - the index of the item to return
Returns:
  the item at the given index
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getItem

public TableItem getItem(Point point)
Returns the item at the given point in the receiver or null if no such item exists. The point is in the coordinate system of the receiver.

The item that is returned represents an item that could be selected by the user. For example, if selection only occurs in items in the first column, then null is returned if the point is outside of the item. Note that the SWT.FULL_SELECTION style hint, which specifies the selection policy, determines the extent of the selection.

Parameters:
  `point` - the point used to locate the item
Returns:
  the item at the given point, or null if the point is not in a selectable item
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the point is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getItemCount

public int getItemCount()
Returns the number of items contained in the receiver.

Returns:
  the number of items
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getItemHeight

public int getItemHeight()
Returns the height of the area which would be used to display one of the items in the receiver.

Returns:
  the height of one item
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getItems

public TableItem[] getItems()
Returns a (possibly empty) array of `TableItem`s which are the items in the receiver.

Note: This is not the actual structure used by the receiver to maintain its list of items, so modifying the array will not affect the receiver.

Returns:
  the items in the receiver
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getLinesVisible

public boolean getLinesVisible()
Returns `true` if the receiver's lines are visible, and `false` otherwise. Note that some platforms draw grid lines while others may draw alternating row colors.

If one of the receiver's ancestors is not visible or some other condition makes the receiver not visible, this method may still indicate that it is considered visible even though it may not actually be showing.

Returns:
  the visibility state of the lines
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getSelection

public TableItem[] getSelection()
Returns an array of `TableItem`s that are currently selected in the receiver. The order of the items is unspecified. An empty array indicates that no items are selected.

Note: This is not the actual structure used by the receiver to maintain its selection, so modifying the array will not affect the receiver.

Returns:
  an array representing the selection
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getSelectionCount

public int getSelectionCount()
Returns the number of selected items contained in the receiver.

Returns:
  the number of selected items
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getSelectionIndex

public int getSelectionIndex()
Returns the zero-relative index of the item which is currently selected in the receiver, or -1 if no item is selected.

Returns:
  the index of the selected item
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getSelectionIndices

public int[] getSelectionIndices()
Returns the zero-relative indices of the items which are currently selected in the receiver. The order of the indices is unspecified. The array is empty if no items are selected.

Note: This is not the actual structure used by the receiver to maintain its selection, so modifying the array will not affect the receiver.

Returns:
  the array of indices of the selected items
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getSortColumn

public TableColumn getSortColumn()
Returns the column which shows the sort indicator for the receiver. The value may be null if no column shows the sort indicator.

Returns:
  the sort indicator
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.2
See Also:
  - `setSortColumn(TableColumn)`

### getSortDirection

public int getSortDirection()
Returns the direction of the sort indicator for the receiver. The value will be one of `UP`, `DOWN` or `NONE`.

Returns:
  the sort direction
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.2
See Also:
  - `setSortDirection(int)`

### getTopIndex

public int getTopIndex()
Returns the zero-relative index of the item which is currently at the top of the receiver. This index can change when items are scrolled or new items are added or removed.

Returns:
  the index of the top item
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### indexOf

public int indexOf(TableColumn column)
Searches the receiver's list starting at the first column (index 0) until a column is found that is equal to the argument, and returns the index of that column. If no column is found, returns -1.

Parameters:
  `column` - the search column
Returns:
  the index of the column
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the column is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### indexOf

public int indexOf(TableItem item)
Searches the receiver's list starting at the first item (index 0) until an item is found that is equal to the argument, and returns the index of that item. If no item is found, returns -1.

Parameters:
  `item` - the search item
Returns:
  the index of the item
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the item is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### isSelected

public boolean isSelected(int index)
Returns `true` if the item is selected, and `false` otherwise. Indices out of range are ignored.

Parameters:
  `index` - the index of the item
Returns:
  the selection state of the item at the index
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### remove

public void remove(int[] indices)
Removes the items from the receiver's list at the given zero-relative indices.

Parameters:
  `indices` - the array of indices of the items
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
  - ERROR_NULL_ARGUMENT - if the indices array is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### remove

public void remove(int index)
Removes the item from the receiver at the given zero-relative index.

Parameters:
  `index` - the index for the item
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### remove

public void remove(int start, int end)
Removes the items from the receiver which are between the given zero-relative start and end indices (inclusive).

Parameters:
  `start` - the start of the range
  `end` - the end of the range
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if either the start or end are not between 0 and the number of elements in the list minus 1 (inclusive)
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### removeAll

public void removeAll()
Removes all of the items from the receiver.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### removeSelectionListener

public void removeSelectionListener(SelectionListener listener)
Removes the listener from the collection of listeners who will be notified when the user changes the receiver's selection.

Parameters:
  `listener` - the listener which should no longer be notified
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `SelectionListener`
  - `addSelectionListener(SelectionListener)`

### select

public void select(int[] indices)
Selects the items at the given zero-relative indices in the receiver. The current selection is not cleared before the new items are selected.

If the item at a given index is not selected, it is selected. If the item at a given index was already selected, it remains selected. Indices that are out of range and duplicate indices are ignored. If the receiver is single-select and multiple indices are specified, then all indices are ignored.

Parameters:
  `indices` - the array of indices for the items to select
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the array of indices is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `setSelection(int[])`

### select

public void select(int index)
Selects the item at the given zero-relative index in the receiver. If the item at the index was already selected, it remains selected. Indices that are out of range are ignored.

Parameters:
  `index` - the index of the item to select
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### select

public void select(int start, int end)
Selects the items in the range specified by the given zero-relative indices in the receiver. The range of indices is inclusive. The current selection is not cleared before the new items are selected.

If an item in the given range is not selected, it is selected. If an item in the given range was already selected, it remains selected. Indices that are out of range are ignored and no items will be selected if start is greater than end. If the receiver is single-select and there is more than one item in the given range, then all indices are ignored.

Parameters:
  `start` - the start of the range
  `end` - the end of the range
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `setSelection(int,int)`

### selectAll

public void selectAll()
Selects all of the items in the receiver.

If the receiver is single-select, do nothing.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setColumnOrder

public void setColumnOrder(int[] order)
Sets the order that the items in the receiver should be displayed in to the given argument which is described in terms of the zero-relative ordering of when the items were added.

Parameters:
  `order` - the new order to display the items
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the item order is null
  - ERROR_INVALID_ARGUMENT - if the item order is not the same length as the number of items
Since:
  3.1
See Also:
  - `getColumnOrder()`
  - `TableColumn.getMoveable()`
  - `TableColumn.setMoveable(boolean)`
  - `SWT.Move`

### setFont

public void setFont(Font font)
Description copied from class: `Control`
Sets the font that the receiver will use to paint textual information to the font specified by the argument, or to the default font for that kind of control if the argument is null.

Overrides:
  `setFont` in class `Control`
Parameters:
  `font` - the new font (or null)

### setHeaderBackground

public void setHeaderBackground(Color color)
Sets the header background color to the color specified by the argument, or to the default system color if the argument is null.

Note: This operation is a HINT and is not supported on all platforms. If the native header has a 3D look and feel (e.g. Windows 7), this method will cause the header to look FLAT irrespective of the state of the table style.

Parameters:
  `color` - the new color (or null)
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the argument has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.106

### setHeaderForeground

public void setHeaderForeground(Color color)
Sets the header foreground color to the color specified by the argument, or to the default system color if the argument is null.

Note: This operation is a HINT and is not supported on all platforms. If the native header has a 3D look and feel (e.g. Windows 7), this method will cause the header to look FLAT irrespective of the state of the table style.

Parameters:
  `color` - the new color (or null)
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the argument has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.106

### setHeaderVisible

public void setHeaderVisible(boolean show)
Marks the receiver's header as visible if the argument is `true`, and marks it invisible otherwise.

If one of the receiver's ancestors is not visible or some other condition makes the receiver not visible, marking it visible may not actually cause it to be displayed.

Parameters:
  `show` - the new visibility state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setItemCount

public void setItemCount(int count)
Sets the number of items contained in the receiver.

Parameters:
  `count` - the number of items
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.0

### setLinesVisible

public void setLinesVisible(boolean show)
Marks the receiver's lines as visible if the argument is `true`, and marks it invisible otherwise. Note that some platforms draw grid lines while others may draw alternating row colors.

If one of the receiver's ancestors is not visible or some other condition makes the receiver not visible, marking it visible may not actually cause it to be displayed.

Parameters:
  `show` - the new visibility state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setRedraw

public void setRedraw(boolean redraw)
Description copied from class: `Control`
If the argument is `false`, causes subsequent drawing operations in the receiver to be ignored. No drawing of any kind can occur in the receiver until the flag is set to true. Graphics operations that occurred while the flag was `false` are lost. When the flag is set to `true`, the entire widget is marked as needing to be redrawn. Nested calls to this method are stacked.

Note: This operation is a hint and may not be supported on some platforms or for some widgets.

Overrides:
  `setRedraw` in class `Control`
Parameters:
  `redraw` - the new redraw state
See Also:
  - `Control.redraw(int, int, int, int, boolean)`
  - `Control.update()`

### setSelection

public void setSelection(int[] indices)
Selects the items at the given zero-relative indices in the receiver. The current selection is cleared before the new items are selected, and if necessary the receiver is scrolled to make the new selection visible.

Indices that are out of range and duplicate indices are ignored. If the receiver is single-select and multiple indices are specified, then all indices are ignored.

Parameters:
  `indices` - the indices of the items to select
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the array of indices is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `deselectAll()`
  - `select(int[])`

### setSelection

public void setSelection(TableItem item)
Sets the receiver's selection to the given item. The current selection is cleared before the new item is selected, and if necessary the receiver is scrolled to make the new selection visible.

If the item is not in the receiver, then it is ignored.

Parameters:
  `item` - the item to select
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the item is null
  - ERROR_INVALID_ARGUMENT - if the item has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.2

### setSelection

public void setSelection(TableItem[] items)
Sets the receiver's selection to be the given array of items. The current selection is cleared before the new items are selected, and if necessary the receiver is scrolled to make the new selection visible.

Items that are not in the receiver are ignored. If the receiver is single-select and multiple items are specified, then all items are ignored.

Parameters:
  `items` - the array of items
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the array of items is null
  - ERROR_INVALID_ARGUMENT - if one of the items has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `deselectAll()`
  - `select(int[])`
  - `setSelection(int[])`

### setSelection

public void setSelection(int index)
Selects the item at the given zero-relative index in the receiver. The current selection is first cleared, then the new item is selected, and if necessary the receiver is scrolled to make the new selection visible.

Parameters:
  `index` - the index of the item to select
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `deselectAll()`
  - `select(int)`

### setSelection

public void setSelection(int start, int end)
Selects the items in the range specified by the given zero-relative indices in the receiver. The range of indices is inclusive. The current selection is cleared before the new items are selected, and if necessary the receiver is scrolled to make the new selection visible.

Indices that are out of range are ignored and no items will be selected if start is greater than end. If the receiver is single-select and there is more than one item in the given range, then all indices are ignored.

Parameters:
  `start` - the start index of the items to select
  `end` - the end index of the items to select
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `deselectAll()`
  - `select(int,int)`

### setSortColumn

public void setSortColumn(TableColumn column)
Sets the column used by the sort indicator for the receiver. A null value will clear the sort indicator. The current sort column is cleared before the new column is set.

Parameters:
  `column` - the column used by the sort indicator or `null`
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the column is disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.2

### setSortDirection

public void setSortDirection(int direction)
Sets the direction of the sort indicator for the receiver. The value can be one of `UP`, `DOWN` or `NONE`.

Parameters:
  `direction` - the direction of the sort indicator
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.2

### setTopIndex

public void setTopIndex(int index)
Sets the zero-relative index of the item which is currently at the top of the receiver. This index can change when items are scrolled or new items are added and removed.

Parameters:
  `index` - the index of the top item
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### showColumn

public void showColumn(TableColumn column)
Shows the column. If the column is already showing in the receiver, this method simply returns. Otherwise, the columns are scrolled until the column is visible.

Parameters:
  `column` - the column to be shown
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the column is null
  - ERROR_INVALID_ARGUMENT - if the column has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.0

### showItem

public void showItem(TableItem item)
Shows the item. If the item is already showing in the receiver, this method simply returns. Otherwise, the items are scrolled until the item is visible.

Parameters:
  `item` - the item to be shown
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the item is null
  - ERROR_INVALID_ARGUMENT - if the item has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `showSelection()`

### showSelection

public void showSelection()
Shows the selection. If the selection is already showing in the receiver, this method simply returns. Otherwise, the items are scrolled until the selection is visible.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  - `showItem(TableItem)`